// Disclaimer:
// This software is provided AS IS for educational purposes only,
// with no warranties, and confers no rights. Error checking is 
// elided for clarity. Carry out sufficient tests prior to using
// it in a productive environment.
// CASIO Europe GmbH accepts no responsibility for loss or damage
// arising from its use, including damage from virus.
//
// Please, note: This configuration information may be changed
// without any further notice.
// Casio Europe GmbH does not guarantee future compatibility. By 
// using this software you agree to these terms and conditions.
//
// Version 1.00 - April 20, 2012
// Supported Devices: DT-X7, DT-X8, DT-X30CE
//
// Remarks: You need latest patches and runtime libraries installed
// onto your mobile device.
//
//////////////////////////////////////////////////////////////////////

// On some devices, functions keys are mapped to special functionality
// in order to provide easy navigation.
// This sample application remaps hardware keys F1 to F8 and assigns 
// key codes "F1" to "F8". 
// As a result, functions keys can be used as they are labeled, e.g.
// for terminal emulation.

#include "stdafx.h"
#include "SystemLib.h"

#define KEYID_FIRST KEYID_F1
#define KEYID_LAST	KEYID_F8

void RemapKey(WORD wKeyMode);
DWORD GetKeyCode(DWORD dwKeyID);

int _tmain(int argc, _TCHAR* argv[])
{
	RemapKey(KEY_MODE_NUM);
	RemapKey(KEY_MODE_ALPHA);
	RemapKey(KEY_MODE_ALPHAS);
	SysSetUserDefineKeyState(TRUE);

	return 0;
}

void RemapKey(WORD wKeyMode)
{
	DWORD buffer[16];
	memset(buffer, 0, sizeof(buffer));

	for(DWORD dwKeyID = KEYID_FIRST; dwKeyID <= KEYID_LAST; dwKeyID++)
	{
		DWORD dwKeyCode = GetKeyCode(dwKeyID);

		if (dwKeyCode != -1)
		{
			buffer[0] = dwKeyCode;
			SysSetUserDefineKey(wKeyMode, dwKeyID, buffer);
		}
	}
}

DWORD GetKeyCode(DWORD dwKeyID)
{
	DWORD dwResult = -1;

	switch(dwKeyID)
	{
	case KEYID_F1:
		dwResult = VF_NO_FIX_PAGE | VK_F1;
		break;
	case KEYID_F2:
		dwResult = VF_NO_FIX_PAGE | VK_F2;
		break;
	case KEYID_F3:
		dwResult = VF_NO_FIX_PAGE | VK_F3;
		break;
	case KEYID_F4:
		dwResult = VF_NO_FIX_PAGE | VK_F4;
		break;
	case KEYID_F5:
		dwResult = VF_NO_FIX_PAGE | VK_F5;
		break;
	case KEYID_F6:
		dwResult = VF_NO_FIX_PAGE | VK_F6;
		break;
	case KEYID_F7:
		dwResult = VF_NO_FIX_PAGE | VK_F7;
		break;
	case KEYID_F8:
		dwResult = VF_NO_FIX_PAGE | VK_F8;
		break;
	default:
		break;
	}

	return dwResult;
}

